package cn.hhj.handler;

import cn.hhj.request.RpcRequest;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class ProcessorHandler implements Runnable {

    private Object service;
    private Socket socket;

    public ProcessorHandler(Socket socket,Object service ) {
        this.socket = socket;
        this.service = service;
    }

    @Override
    public void run() {
        ObjectInputStream is=null;
        ObjectOutputStream os=null;
        try{
            is=new ObjectInputStream(socket.getInputStream());
            RpcRequest request= (RpcRequest) is.readObject();
            Object result=invoke(request); //反射调用本地服务
            os=new ObjectOutputStream(socket.getOutputStream());
            os.writeObject(result);
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            try { if (is!=null){ is.close(); } } catch (IOException e) { e.printStackTrace(); }
            try { if (os!=null){ os.close(); } } catch (IOException e) { e.printStackTrace(); }
        }
    }

    private Object invoke(RpcRequest rpcRequest)throws  Exception{
        Object[] params=rpcRequest.getParameters();// 请求参数
        Class<?>[] types=new Class[params.length];//保存请求参数的类型
        for (int i = 0; i < params.length; i++) {
            types[i]=params[i].getClass();
        }
        Class clazz=Class.forName(rpcRequest.getClassName());
        return clazz.getMethod(rpcRequest.getMethodName(),types).invoke(service,params);
    }
}
